﻿using System;
using UnityEngine;

namespace Framework.Dto
{

    [Serializable]
    public class EventStepInfo
    {
        [SerializeField] public int StepIndex { get; private set; }
        [SerializeField] public int ActionIndex { get; private set; }
        [SerializeField] public string ObjectName { get; private set; }

        public Action Event { get; private set; }

        // 构造函数，允许传入 UnityEvent 作为参数
        public EventStepInfo(int stepIndex, int actionIndex, string objectName, Action customEvent)
        {
            StepIndex = stepIndex;
            ActionIndex = actionIndex;
            ObjectName = objectName;
            Event = customEvent;
        }
    }
}