using System.Collections.Generic;

namespace DefaultNamespace.ProcessMode
{
    /// <summary>
    /// 流程集合
    /// </summary>
    public class ProcessCollection
    {
        public string Type { get; set; }         // 流程类型（例如：教学、培训、练习）
        public List<ProcessStep> Steps { get; private set; }  // 流程中的步骤列表
        
        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="type">流程类型</param>
        public ProcessCollection(string type)
        {
            Type = type;
            Steps = new List<ProcessStep>();
        }
        
        /// <summary>
        /// 添加步骤到流程中
        /// </summary>
        /// <param name="step">要添加的步骤</param>
        public void AddStep(ProcessStep step)
        {
            Steps.Add(step);
        }
        
    }
}